//---------------------------------------------------------------------------

#include <fmx.h>
#pragma hdrstop

#include "Unit10.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FMXTee.Tools"
#pragma resource "*.fmx"
TForm10 *Form10;

double XVal;
Boolean DirtyX;
Boolean DirtyRect;
//---------------------------------------------------------------------------
__fastcall TForm10::TForm10(TComponent* Owner)
	: TForm(Owner)
{
   Series1->FillSampleValues(100);

   ChartToolRect->Left = 100;
   ChartToolRect->Width = 100;
   ChartToolRect->Top = Chart1->MarginTop;
   ChartToolRect->Height = Chart1->Height - Chart1->MarginTop - Chart1->MarginBottom;
   ChartToolRect->AllowDrag = false;
   ChartToolRect->AllowResize = false;

   DirtyX=True;
   DirtyRect=False;

   //Chart1->Draw();
   //XVal=Chart1->Axes->Bottom->InternalCalcPosPoint(ChartToolRect->Left);
}
//---------------------------------------------------------------------------
void __fastcall TForm10::Chart1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  float X, float Y)
{
   if (Y > Chart1->Height * 1 / 2)
	  return;

   // Move to the cusor position
   ChartToolRect->Left = X;
   DirtyX=True;
}
//---------------------------------------------------------------------------
void __fastcall TForm10::Chart1Scroll(TObject *Sender)
{
	DirtyRect=True;
}
//---------------------------------------------------------------------------
void __fastcall TForm10::Chart1AfterDraw(TObject *Sender)
{
	if (DirtyX)
	{
		XVal=Chart1->Axes->Bottom->InternalCalcPosPoint(ChartToolRect->Left);
		DirtyX=False;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm10::ChartToolRectAfterDraw(TObject *Sender)
{
	if (DirtyRect)
	{
		DirtyRect=False;
		ChartToolRect->Left = Series1->CalcXPosValue(XVal);
		Chart1->Draw();
	}
}
//---------------------------------------------------------------------------

